package si.url.rpr.generator;

import java.util.Arrays;

import si.url.rpr.snippet.Utils;

public class BruteForce implements Generator {

	private char[] cs; // Character Set
	private char[] cg; // Current Guess

	private int threads = 1;

	public BruteForce(char[] characterSet, String passwordStart, int threads, int threadIndex) {
		Arrays.sort(characterSet);
		cs = characterSet;
		int guessLength = passwordStart.length();
		cg = new char[guessLength];
		this.threads = threads;
		// Arrays.fill(cg, cs[0]);
		cg = Utils.stripString(passwordStart, characterSet).toCharArray();

		for (int i = 0; i < threadIndex; i++) {
			_increment();
		}
	}

	public String increment() {
		for (int i = 0; i < threads - 1; i++) {
			_increment();
		}
		return _increment();
	}

	private String _increment() {
		String pass = String.valueOf(cg);

		int index = cg.length - 1;
		while (index >= 0) {
			if (cg[index] == cs[cs.length - 1]) {
				if (index == 0) {
					cg = new char[cg.length + 1];
					Arrays.fill(cg, cs[0]);
					break;
				} else {
					cg[index] = cs[0];
					index--;
				}
			} else {
				cg[index] = cs[Arrays.binarySearch(cs, cg[index]) + 1];
				break;
			}
		}

		return pass;
	}

	@Override
	public long getLength() {
		return Long.MAX_VALUE;
	}

}