package si.url.rpr.generator;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;

import si.url.rpr.snippet.Utils;

public class Dictionary implements Generator {

	private int threads = 1;

	private BufferedReader br;
	private File dictionary;
	private long dictionaryLength = -1;

	public Dictionary(File dictionary, int threads, int threadIndex) {
		this.dictionary = dictionary.getAbsoluteFile();
		this.threads = threads;
		try {
			FileInputStream fstream = new FileInputStream(this.dictionary);
			DataInputStream in = new DataInputStream(fstream);
			br = new BufferedReader(new InputStreamReader(in));
		} catch (Exception e) {
			Utils.log(e);
		}

		for (int i = 0; i < threadIndex; i++) {
			_increment();
		}
	}

	public String increment() {
		for (int i = 0; i < threads - 1; i++) {
			_increment();
		}
		return _increment();
	}

	private String _increment() {
		String password = null;
		try {
			password = br.readLine();
		} catch (Exception e) {
			Utils.log(e);
		}
		return password;
	}

	public long getLength() {

		if (dictionaryLength != -1)
			return dictionaryLength;

		try {
			dictionaryLength = 0;
			FileInputStream stream = new FileInputStream(dictionary);
			byte[] buffer = new byte[8192];
			dictionaryLength = 0;
			int n;
			while ((n = stream.read(buffer)) > 0) {
				for (int i = 0; i < n; i++) {
					if (buffer[i] == '\n')
						dictionaryLength++;
				}
			}
			stream.close();
		} catch (Exception e) {
			Utils.log(e);
		}

		return dictionaryLength;
	}

}