package si.url.rpr.generator;

import java.io.File;

public class GeneratorBuilder {

	public static enum Source {
		BROUTE_FORCE, DICTIONARY
	};

	private Source source = Source.BROUTE_FORCE;
	private char[] characterSet;
	private String passwordStart;
	private int threads;
	private File dictionary;

	public void setThreads(int threads) {
		this.threads = threads;
	}

	public void setDictionary(File dictionary) {
		this.dictionary = dictionary;
		if (dictionary != null)
			this.source = Source.DICTIONARY;
		else
			this.source = Source.BROUTE_FORCE;
	}

	public void setCharacterSet(char[] characterSet) {
		this.characterSet = characterSet;
	}

	public void setPasswordStart(String passwordStart) {
		this.passwordStart = passwordStart;
	}

	public Generator build(int threadIndex) {
		Generator generator = null;
		switch (source) {
		case BROUTE_FORCE:
			generator = new BruteForce(characterSet, passwordStart, threads, threadIndex);
			break;
		case DICTIONARY:
			generator = new Dictionary(dictionary, threads, threadIndex);
			break;
		}
		return generator;
	}
}
