package si.url.rpr.snippet;

import android.util.Log;

public class Utils {

	public static final boolean DEBUG = true;
	private static final String TAG = "RPR";

	public static void log(String string) {
		if (!DEBUG)
			return;
		Log.d(TAG, string);
	}

	public static void log(Exception e) {
		log("Exception: " + e.getMessage());
		StackTraceElement[] stack = e.getStackTrace();
		for (StackTraceElement el : stack) {
			log(el.toString());
		}
	}

	public static String intToIp(int i) {
		return (i & 0xFF) + "." + ((i >> 8) & 0xFF) + "." + ((i >> 16) & 0xFF) + "." + ((i >> 24) & 0xFF);
	}

	public static String stripString(String s, char[] good) {
		String goodString = new String(good);
		String result = "";
		for (int i = 0; i < s.length(); i++) {
			if (goodString.indexOf(s.charAt(i)) >= 0)
				result += s.charAt(i);
		}
		return result;
	}
}