package si.url.rpr.tester;

import java.net.HttpURLConnection;
import java.net.URL;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import si.url.rpr.snippet.Base64;
import si.url.rpr.snippet.Utils;

public class Tester {

	private static boolean sslEnabled = false;

	public static void testAuth(String url, Callback2 cb) {

		System.setProperty("http.keepAlive", "false");

		try {
			URL urlO = new URL(url);

			int status = test(urlO, "admin", "fasd2DgeE34Bd33fDAf");
			if (status != 401) {
				cb.onFailure();
			} else {
				cb.onSuccess();
			}

		} catch (Exception e) {
			Utils.log(e);
		}

	}

	public static int test(URL url, String username, String password) {

		int status = -1;
		boolean isSSL = url.getProtocol().toLowerCase().equals("https");
		if (!sslEnabled && isSSL) {
			enableSSL();
			sslEnabled = true;
		}

		try {

			HttpURLConnection http;
			if (isSSL) {
				HttpsURLConnection https = (HttpsURLConnection) url.openConnection();
				https.setHostnameVerifier(DO_NOT_VERIFY);
				http = https;
			} else {
				http = (HttpURLConnection) url.openConnection();
			}

			http.setRequestProperty("Accept-Encoding", "identity");
			http.setRequestProperty("connection", "close");
			http.setConnectTimeout(500);
			http.setRequestProperty("Authorization", "Basic " + Base64.encodeToString((username + ":" + password).getBytes(), false));
			http.setUseCaches(false);
			http.connect();

			status = http.getResponseCode();

			http.disconnect();

		} catch (Exception e) {
			Utils.log(e);
		}

		return status;

	}

	// always verify the host - do not check for certificate
	public final static HostnameVerifier DO_NOT_VERIFY = new HostnameVerifier() {
		public boolean verify(String hostname, SSLSession session) {
			return true;
		}
	};

	/**
	 * Trust every server - do not check for any certificate
	 */
	public static void enableSSL() {
		// Create a trust manager that does not validate certificate chains
		TrustManager[] trustAllCerts = new TrustManager[] { new X509TrustManager() {
			public java.security.cert.X509Certificate[] getAcceptedIssuers() {
				return new java.security.cert.X509Certificate[] {};
			}

			public void checkClientTrusted(X509Certificate[] chain, String authType) throws CertificateException {
			}

			public void checkServerTrusted(X509Certificate[] chain, String authType) throws CertificateException {
			}
		} };

		// Install the all-trusting trust manager
		try {
			SSLContext sc = SSLContext.getInstance("TLS");
			sc.init(null, trustAllCerts, new java.security.SecureRandom());
			HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public interface Callback2 {
		public void onSuccess();

		public void onFailure();
	}
}
