package si.url.rpr.tester;

import java.net.URL;

import si.url.rpr.generator.Generator;

public class Worker extends Thread {

	private boolean isRunning = true;

	private String url;
	private String username;
	private Callback cb;

	private long speedTime = System.currentTimeMillis();
	private int speedCount = 0;
	private long count = 0;

	private Generator generator;

	private String password = "";

	public Worker(Generator generator, String url, String username, int threads, Callback cb) {
		this.generator = generator;
		this.url = url;
		this.username = username;
		this.cb = cb;
	}

	@Override
	public void run() {
		int status = 0;

		URL urlO = null;
		try {
			urlO = new URL(url);
		} catch (Exception e) {
			return;
		}

		System.setProperty("http.keepAlive", "false");

		while (isRunning && status != 200) {

			if (status != -1) {
				password = generator.increment();
				if (password == null) {
					isRunning = false;
					break;
				}
			}

			status = Tester.test(urlO, username, password);

			if (status != -1) {
				speedCount++;
				count++;
			}

		}

		if (isRunning) {
			cb.onFound(password);
		}

		cb.onFinish();
	}

	public float getSpeed() {
		long currentTime = System.currentTimeMillis();
		float elapsedTime = currentTime - speedTime;
		int count = speedCount;
		speedTime = currentTime;
		speedCount = 0;
		return count / (elapsedTime / 1000);
	}

	public long getCount() {
		return count;
	}

	public String getPassword() {
		return password;
	}

	public void end() {
		isRunning = false;
	}

	public boolean isRunning() {
		return isRunning;
	}

	public Generator getGenerator() {
		return generator;
	}

	public interface Callback {
		public void onFound(String password);

		public void onFinish();
	}
}